Attribute VB_Name = "Outils3D"
Option Explicit
'
Global Const PI As Double = 3.14159265358979
'
Global dxD3Drm As IDirect3DRM2
Global dxScene As IDirect3DRMFrame2 ' Scene Mre: Master scene
Global dxCamera As IDirect3DRMFrame2 ' La camra: the camera
Global dxLightFrame As IDirect3DRMFrame2 ' Scene lumire: Light scene
Global dxLight As IDirect3DRMLight ' Lumire : Principal light
Global dxAmbientLight As IDirect3DRMLight ' Lumire d'ambience: Ambient light
Global dxOmbre As IDirect3DRMShadow
Global dxClipper As IDirectDrawClipper
Global dxDevice As IDirect3DRMDevice2
Global dxViewport As IDirect3DRMViewPort
'
' ***** Qualite d'affichage: Quality
'
'Global Const QUALITE_NORMAL& = D3DRMLIGHT_ON + D3DRMFILL_SOLID + D3DRMSHADE_GOURAUD
Global Const QUALITE_NORMAL& = D3DRMLIGHT_ON + D3DRMFILL_SOLID + D3DSHADE_FLAT
Global Const QUALITE_VISION& = D3DRMLIGHT_ON + D3DRMFILL_WIREFRAME + D3DRMSHADE_GOURAUD
'
Global Const TCase! = 10 ' Taille d'une case: Size

'
' ***************************************
' Chargement d'un fichier .x
' avec modification du dossier de travail
' Load a .x file
' with change of the working path
' ***************************************
'
Public Function Charge_X(Nom$) As IDirect3DRMMeshBuilder2
On Error GoTo continue
    Dim DossierActuel$
    Dim i%, n%
    Call dxD3Drm.CreateMeshBuilder(Charge_X)
    n% = 0
    For i% = 1 To Len(Nom$)
        If Mid$(Nom$, i%, 1) = "\" Then n% = i%
    Next i%
    DossierActuel$ = CurDir$
    ChDir Mid$(Nom$, 1, n% - 1)
    Call Charge_X.Load("." & Mid$(Nom$, n%, Len(Nom$) - n% + 1), 0, 0, 0, 0)
    Call Charge_X.SetPerspective(1)
continue:
    ChDir DossierActuel$
End Function

'
' *********************
' Mise  jour de la vue
' Calculate the view
' *********************
'
Public Sub Affiche_Vue3D()
    
' It's look like their no error generate
' by the new .tlb : Thank to Patrice, he save us from hell!
    
    'Dim t1!
    'On Error Resume Next
    With dxViewport
        Call .Clear
        Call .Render(dxScene)
    End With
    Call dxDevice.Update
    't1! = Timer ' Pour provoquer l'erreur rsiduelle
    'On Error GoTo 0
End Sub

'
' ***************************
' Cre la zone d'affichage 3D
' Create the 3D view
' ***************************
'
Public Sub Zone3D_Cree(zone As Object, tx%, ty%)
    Dim dixuDDraw As IDirectDraw2
    Dim d3d As IDirect3D2
    Dim fds As D3DFINDDEVICESEARCH
    Dim fdr As D3DFINDDEVICERESULT
    Call DirectDrawCreate(ByVal 0&, dixuDDraw, Nothing)
    Set d3d = dixuDDraw
    ' Search for the color model
    fds.dwSize = Len(fds)
    fds.dwFlags = D3DFDS_COLORMODEL
    '
    fds.dcmColorModel = D3DCOLOR_RGB
    'fds.dcmColorModel = D3DCOLOR_MONO
    '
    fdr.dwSize = Len(fdr)
    ' Find the driver
    Call d3d.FindDevice(fds, fdr)
    '
    ' ***** Remise a niveau si rappel de la fonction
    '
    Set dxViewport = Nothing
    Set dxDevice = Nothing
    Set dxClipper = Nothing
    '
    Call DirectDrawCreateClipper(0, dxClipper, Nothing)
    Call dxClipper.SetHWnd(0, zone.hWnd)
    Call dxD3Drm.CreateDeviceFromClipper(dxClipper, fdr.GUID, tx%, ty%, dxDevice)
    'Call dxD3Drm.CreateDeviceFromClipper(dxClipper, ByVal 0&, tx%, ty%, dxDevice)
    Call dxD3Drm.CreateViewport(dxDevice, dxCamera, 0, 0, tx%, ty%, dxViewport)
    Call dxDevice.SetDither(1)
    Call dxDevice.SetQuality(QUALITE_NORMAL&)
    '
    Set d3d = Nothing
    Set dixuDDraw = Nothing
End Sub

'
' ***************************
' Ajoute la camra  la scne
' Add a camera to the scene
' ***************************
'
Public Sub Ajoute_Camera()
    Call dxD3Drm.CreateFrame(dxScene, dxCamera)
    Call dxCamera.SetPosition(dxScene, 0, TCase! * 4 / TCase!, -TCase!)
End Sub

'
' **************************
' Ajoute la scene principale
' Add the main scene
' **************************
'
Public Sub Ajoute_Scene()
    Call dxD3Drm.CreateFrame(Nothing, dxScene)
End Sub

'
' **************
' Ajoute un spot
' Add a spotlight
' **************
'
Public Sub Ajoute_Spot()
    Call dxD3Drm.CreateFrame(dxCamera, dxLightFrame)
    Call dxD3Drm.CreateLightRGB(D3DRMLIGHT_POINT, 1, 1, 1, dxLight)
    Call dxLightFrame.AddLight(dxLight)
End Sub

'
' ****************************
' Ajoute la lumire d'ambience
' Add ambient light
' ****************************
'
Public Sub Ajoute_Ambience()
    Call dxD3Drm.CreateLightRGB(D3DRMLIGHT_AMBIENT, 1, 1, 1, dxAmbientLight)
    Call dxScene.AddLight(dxAmbientLight)
End Sub

'
' ******************************************
' Efface les objets 3D  la fin du programme
' Erase DirectX object at the end of program
' ******************************************
'
Public Sub Objet3D_Efface()
    Set dxViewport = Nothing
    Set dxDevice = Nothing
    Set dxClipper = Nothing
    Set dxOmbre = Nothing
    Set dxLight = Nothing
    Set dxLightFrame = Nothing
    Set dxAmbientLight = Nothing
    Set dxCamera = Nothing
    Set dxScene = Nothing
    Set dxD3Drm = Nothing
End Sub

'
' **********************
' Cration des objets 3D
' Create 3D object
' **********************
'
Public Sub Objet3D_Cree()
    Call Direct3DRMCreate(dxD3Drm)
    Call Ajoute_Scene
    Call Ajoute_Camera
    Call Ajoute_Spot
    Call Ajoute_Ambience
End Sub

