VERSION 5.00
Begin VB.Form View 
   Caption         =   "Dynamic Light with VB5 & P.Scribe DirectX .tlb"
   ClientHeight    =   5430
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5190
   Icon            =   "View.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   362
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   346
   StartUpPosition =   3  'Windows Default
   Begin VB.HScrollBar HScroll2 
      Height          =   255
      LargeChange     =   10
      Left            =   3840
      Max             =   100
      TabIndex        =   7
      Top             =   4920
      Width           =   1335
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      LargeChange     =   10
      Left            =   3840
      Max             =   100
      TabIndex        =   6
      Top             =   4320
      Width           =   1335
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   1575
      Left            =   240
      Max             =   10
      Min             =   -10
      TabIndex        =   4
      Top             =   3840
      Width           =   255
   End
   Begin VB.CommandButton Command1 
      Height          =   735
      Index           =   3
      Left            =   3000
      Picture         =   "View.frx":08CA
      Style           =   1  'Graphical
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   3960
      Width           =   735
   End
   Begin VB.CommandButton Command1 
      Height          =   735
      Index           =   2
      Left            =   2160
      Picture         =   "View.frx":1FBC
      Style           =   1  'Graphical
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   4680
      Width           =   735
   End
   Begin VB.CommandButton Command1 
      Height          =   735
      Index           =   1
      Left            =   2160
      Picture         =   "View.frx":36AE
      Style           =   1  'Graphical
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   3840
      Width           =   735
   End
   Begin VB.CommandButton Command1 
      Height          =   735
      Index           =   0
      Left            =   1320
      Picture         =   "View.frx":4DA0
      Style           =   1  'Graphical
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   3960
      Width           =   735
   End
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   120
      Top             =   120
   End
   Begin VB.Label Label2 
      Caption         =   "Spot light"
      Height          =   255
      Index           =   1
      Left            =   3840
      TabIndex        =   9
      Top             =   4680
      Width           =   1335
   End
   Begin VB.Label Label2 
      Caption         =   "Ambient light"
      Height          =   255
      Index           =   0
      Left            =   3840
      TabIndex        =   8
      Top             =   4080
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   255
      Left            =   720
      TabIndex        =   5
      Top             =   4920
      Width           =   1215
   End
End
Attribute VB_Name = "View"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' This is a example that what we can do to simulate
' dynamic light with DirectX.
' Of course you can do better, like:
' - set a light range on 2 or more step,
' - mixing light on each case,
' - improve calculating time for render the view,
' like I did for my own program.
' This example just show you how to create dynamic light, not
' the better way to use it. After it's depand of your DirectX engine
' and now it's your job.
' You can walk trought the wall to be sure that all light
' I put don't cross the wall. Look up and down, it's funny.
' Have fun with this.

' EMail me : jean-michel.kerdal@gdf.edfgdf.fr
' 2, place des martyrs de l'occupation
' 92110 Clichy, France

Option Explicit

Dim ViewLight(13, 13) As IDirect3DRMLight
Dim LightFrame(13, 13) As IDirect3DRMFrame2
Dim ViewFrame(13, 13) As IDirect3DRMFrame2
Dim Wall(4) As IDirect3DRMMeshBuilder2
Dim xPosition%, Dx% ' X positon for camera
Dim yPosition%, Dy% ' Y ...
Dim Direction%, Dd% ' Direction for the camera
Dim zPosition% ' Height of the camera
Const Step% = 3 ' Number of step (1 minimum, no maxi but 5 is great)

'
' *******************************
' Move the camera with the arrows
' *******************************
'
Private Sub Command1_Click(Index As Integer)
    If Dx% = 0 And Dy% = 0 And Dd% = 0 Then
        Select Case Index
        Case 0 ' turn left
            If Direction% = 0 Then
                Direction% = 3
            Else
                Direction% = Direction% - 1
            End If
            Dd% = Step% - 1
        Case 1 ' One step beyond
            Select Case Direction%
            Case 0
                yPosition% = yPosition% + 1
                Dy% = 1 - Step%
            Case 1
                xPosition% = xPosition% + 1
                Dx% = 1 - Step%
            Case 2
                yPosition% = yPosition% - 1
                Dy% = Step% - 1
            Case 3
                xPosition% = xPosition% - 1
                Dx% = Step% - 1
            End Select
        Case 2 ' One step forward
            Select Case Direction%
            Case 0
                yPosition% = yPosition% - 1
                Dy% = Step% - 1
            Case 1
                xPosition% = xPosition% - 1
                Dx% = Step% - 1
            Case 2
                yPosition% = yPosition% + 1
                Dy% = 1 - Step%
            Case 3
                xPosition% = xPosition% + 1
                Dx% = 1 - Step%
            End Select
        Case 3 ' turn right
            If Direction% = 3 Then
                Direction% = 0
            Else
                Direction% = Direction% + 1
            End If
            Dd% = 1 - Step%
        End Select
    End If
End Sub

'
' ******************
' End of the program
' ******************
'
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyEscape Then Unload Me
End Sub

'
' ****************
' Create the world
' ****************
'
Private Sub Form_Load()
    Dim i%, j%
    Call Objet3D_Cree
    Call Zone3D_Cree(Me, 320, 250)
    '
    Set Wall(0) = Charge_X(".\mur.x")
    Set Wall(1) = Charge_X(".\sol.x")
    Set Wall(2) = Charge_X(".\red.x")
    Set Wall(3) = Charge_X(".\green.x")
    Set Wall(4) = Charge_X(".\blue.x")
    ' Create all wall & light
    For i% = 0 To 13
        For j% = 0 To 13
            ' Create view
            Call dxD3Drm.CreateFrame(dxScene, ViewFrame(i%, j%))
            Call ViewFrame(i%, j%).SetPosition(dxScene, i% * TCase!, 0, j% * TCase!)
            ' Create light
            Call dxD3Drm.CreateLightRGB(D3DRMLIGHT_SPOT, 0, 0, 0, ViewLight(i%, j%))
            ' Each view size 10*10*8 so you must make a sphere just over each view
            Call ViewLight(i%, j%).SetRange(Sqr(2 * (5 ^ 2) + 4 ^ 2))
            Call ViewLight(i%, j%).SetUmbra(2 * PI) ' Open the spot to the max
            Call ViewLight(i%, j%).SetPenumbra(2 * PI) ' the max
            ' Add light to the view
            Call dxD3Drm.CreateFrame(ViewFrame(i%, j%), LightFrame(i%, j%))
            Call LightFrame(i%, j%).AddLight(ViewLight(i%, j%))
            Call LightFrame(i%, j%).SetPosition(ViewFrame(i%, j%), 0, 4, 0)
        Next j%
    Next i%
    ' Load the map
    Dim Carte$(13)
    Carte$(13) = "    XXX       "
    Carte$(12) = "   X.L.X      "
    Carte$(11) = "   XL.LX      "
    Carte$(10) = "   X...X      "
     Carte$(9) = "    X.X       "
     Carte$(8) = "    XLX  X    "
     Carte$(7) = "    X.XXXRXX  "
     Carte$(6) = "  X X.XL...LX "
     Carte$(5) = " XBXX.X.....X "
     Carte$(4) = "XG...L...X..GX"
     Carte$(3) = " XRXXXX.....X "
     Carte$(2) = "  X   XL...LX "
     Carte$(1) = "       XXBXX  "
     Carte$(0) = "         X    "
    For i% = 0 To 13
        For j% = 0 To 13
            With ViewFrame(j%, i%)
                Select Case Mid$(Carte$(i%), j% + 1, 1)
                Case "X"
                    Call .AddVisual(Wall(0))
                Case "."
                    Call .AddVisual(Wall(1))
                Case "R"
                    Call .AddVisual(Wall(1))
                    Call .AddVisual(Wall(2))
                    Call ViewLight(j%, i%).SetColorRGB(1, 0, 0)
                Case "G"
                    Call .AddVisual(Wall(1))
                    Call .AddVisual(Wall(3))
                    Call ViewLight(j%, i%).SetColorRGB(0, 1, 0)
                Case "B"
                    Call .AddVisual(Wall(1))
                    Call .AddVisual(Wall(4))
                    Call ViewLight(j%, i%).SetColorRGB(0, 0, 1)
                Case "L"
                    Call .AddVisual(Wall(1))
                    Call ViewLight(j%, i%).SetColorRGB(1, 1, 1)
                End Select
            End With
        Next j%
    Next i%
    ' Start position
    xPosition% = 5
    yPosition% = 11
    Direction% = 0
    ' Switch off the extern light
    Call dxAmbientLight.SetColorRGB(0, 0, 0)
    Call dxLight.SetColorRGB(0, 0, 0)
End Sub

'
' ***************
' Destroy objects
' ***************
'
Private Sub Form_Unload(Cancel As Integer)
    Dim i%, j%
    For i% = 0 To 13
        For j% = 0 To 13
            Set ViewLight(i%, j%) = Nothing
            Set LightFrame(i%, j%) = Nothing
            Set ViewFrame(i%, j%) = Nothing
        Next j%
    Next i%
    For i% = 0 To 4
        Set Wall(i%) = Nothing
    Next i%
    Call Objet3D_Efface
End Sub

'
' ********************
' Change ambient light
' ********************
'
Private Sub HScroll1_Change()
    Call dxAmbientLight.SetColorRGB(HScroll1.Value / 100, HScroll1.Value / 100, HScroll1.Value / 100)
End Sub

'
' *****************
' Change spot light
' *****************
'
Private Sub HScroll2_Change()
    Call dxLight.SetColorRGB(HScroll2.Value / 100, HScroll2.Value / 100, HScroll2.Value / 100)
End Sub


'
' ***************************
' Calculating Camera position
' ***************************
'
Private Sub Timer1_Timer()
    Dim angle!
    Dim Timer1!
    Call dxCamera.SetPosition(dxScene, (xPosition% + Dx% / Step%) * TCase!, 4 + zPosition%, (yPosition% + Dy% / Step%) * TCase!)
    angle! = (Direction% + Dd% / Step%) / 4 * 2 * PI
    Call dxCamera.SetOrientation(dxScene, Sin(angle!), 0, Cos(angle!), 0, 1, 0)
    Timer1! = Timer
    Call Affiche_Vue3D
    Label1.Caption = Str$(Timer - Timer1!) & " s"
    Dx% = Dx% - Sgn(Dx%)
    Dy% = Dy% - Sgn(Dy%)
    Dd% = Dd% - Sgn(Dd%)
End Sub

'
' ******************
' Change view height
' ******************
'
Private Sub VScroll1_Change()
    zPosition% = -VScroll1.Value
End Sub

